'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _AbstractComponent2 = require('ima/page/AbstractComponent');

var _AbstractComponent3 = _interopRequireDefault(_AbstractComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Private field symbols.
 *
 * @type {Object<string, symbol>}
 */
var PRIVATE = Object.freeze({
	// fields
	eventBusListeners: Symbol('eventBusListeners'),
	domListeners: Symbol('domListeners'),
	dispatcherListeners: Symbol('dispatcherListeners'),
	pendingTimeouts: Symbol('pendingTimeouts'),
	activeIntervals: Symbol('activeIntervals'),

	// methods
	registerListener: Symbol('registerListener'),
	deregisterListener: Symbol('deregisterListener'),
	bindUiEventListeners: Symbol('bindUiEventListeners')
});

/**
 * Abstract UI component that automatically manages the registered DOM, event
 * bus and dispatcher event listeners, timeouts and intervals. The component
 * automatically deregisters all of these right before the component unmounts
 * from the DOM.
 *
 * @abstract
 */

var AbstractManagedComponent = function (_AbstractComponent) {
	_inherits(AbstractManagedComponent, _AbstractComponent);

	/**
  * Initializes the component.
  *
  * @param {Object<string, *>} props Component properties.
  * @param {Object<string, *>} context Component's context.
  */
	function AbstractManagedComponent(props, context) {
		_classCallCheck(this, AbstractManagedComponent);

		var _this = _possibleConstructorReturn(this, (AbstractManagedComponent.__proto__ || Object.getPrototypeOf(AbstractManagedComponent)).call(this, props, context));

		if (!_this.utils || !_this.utils.$Dispatcher) {
			throw new Error('The view utils must be provided to the managed ' + 'component either via props or context as $Utils ' + 'property. The property\'s value must be an object with ' + 'the IMA event dispatcher available through the ' + '$Dispatcher property');
		}

		if (_this.componentWillUnmount !== AbstractManagedComponent.prototype.componentWillUnmount) {
			(function () {
				var currentComponentWillUnmount = _this.componentWillUnmount;
				_this.componentWillUnmount = function () {
					currentComponentWillUnmount.call(_this);
					// Possible repeated calls to our implementation of the
					// componentWillUnmount method will have no effect.
					AbstractManagedComponent.prototype.componentWillUnmount.call(_this);
				};
			})();
		}

		var currentRender = _this.render;
		_this.render = function () {
			return _this[PRIVATE.bindUiEventListeners](currentRender.call(_this));
		};

		/**
   * Storage of the registered DOM event listeners.
   *
   * @type {Map<EventTarget, Map<string, Map<
   *         function(Event),
   *         function(Event)
   *       >>>}
   */
		_this[PRIVATE.domListeners] = new Map();

		/**
   * Storage of the registered event bus listeners.
   *
   * @type {Map<EventTarget, Map<string, Map<
   *         function(Event),
   *         function(Event)
   *       >>>}
   */
		_this[PRIVATE.eventBusListeners] = new Map();

		/**
   * Map of dispatcher event names to the registered callbacks.
   *
   * @type {Map<string, Set<function(*)>>}
   */
		_this[PRIVATE.dispatcherListeners] = new Map();

		/**
   * Map of registered callbacks executed with a delay that have not
   * been executed yet to the native timeout IDs.
   *
   * @type {Map<function(), number>}
   */
		_this[PRIVATE.pendingTimeouts] = new Map();

		/**
   * Map of registered callbacks executed periodically to the native
   * interval IDs.
   *
   * @type {Map<function(), number>}
   */
		_this[PRIVATE.activeIntervals] = new Map();
		return _this;
	}

	/**
  * Registers the provided event listener for execution when the
  * specified event occurs at the specified event target.
  *
  * The listener will be automatically deregistered right before the
  * component will be unmounted from the DOM (by the
  * {@linkcode componentWillUnmount()} method).
  *
  * The listener will automatically have its {@code this} context bound
  * to this instance.
  *
  * @param {(ReactComponent|EventTarget)} eventTarget The event target
  *        at which the event is to be listened for.
  * @param {string} eventName The name of the event to listen for.
  * @param {function(Event)} listener The listener to register.
  */


	_createClass(AbstractManagedComponent, [{
		key: 'addDomListener',
		value: function addDomListener(eventTarget, eventName, listener) {
			if (!eventTarget.addEventListener) {
				eventTarget = this.findDOMNode(eventTarget);
			}

			var realListener = this[PRIVATE.registerListener](this[PRIVATE.domListeners], eventTarget, eventName, listener);

			if (realListener) {
				eventTarget.addEventListener(eventName, realListener);
			}
		}

		/**
   * Deregisters the specified event listener from execution of the
   * specified DOM event on the provided event target.
   *
   * The method has no effect if the listener is not registered.
   *
   * @param {(ReactComponent|EventTarget)} eventTarget The event target
   *        at which the event was listened for.
   * @param {string} eventName The name of the event listened for.
   * @param {function(Event)} listener The listener to deregister.
   */

	}, {
		key: 'removeDomListener',
		value: function removeDomListener(eventTarget, eventName, listener) {
			if (!eventTarget.addEventListener) {
				eventTarget = this.findDOMNode(eventTarget);
			}

			var realListener = this[PRIVATE.deregisterListener](this[PRIVATE.domListeners], eventTarget, eventName, listener);

			if (realListener) {
				eventTarget.removeEventListener(eventName, realListener);
			}
		}

		/**
   * Registers the provided event listener for execution whenever an
   * IMA.js DOM custom event of the specified name occurs at the
   * specified event target.
   *
   * The listener will be automatically deregistered right before the
   * component will be unmounted from the DOM (by the
   * {@linkcode componentWillUnmount()} method).
   *
   * The listener will automatically have its {@code this} context bound
   * to this instance.
   *
   * @method listen
   * @param {(ReactElement|EventTarget)} eventTarget The react component
   *        or event target at which the listener should listen for the
   *        event.
   * @param {string} eventName The name of the event for which to listen.
   * @param {function(Event)} listener The listener for event to
   *        register.
   */

	}, {
		key: 'listen',
		value: function listen(eventTarget, eventName, listener) {
			var realListener = this[PRIVATE.registerListener](this[PRIVATE.eventBusListeners], eventTarget, eventName, listener);

			if (realListener) {
				_get(AbstractManagedComponent.prototype.__proto__ || Object.getPrototypeOf(AbstractManagedComponent.prototype), 'listen', this).call(this, eventTarget, eventName, realListener);
			}
		}

		/**
   * Deregisters the provided event listener for an IMA.js DOM custom
   * event of the specified name at the specified event target.
   *
   * @method unlisten
   * @param {(ReactElement|EventTarget)} eventTarget The react component
   *        or event target at which the listener should listen for the
   *        event.
   * @param {string} eventName The name of the event for which to listen.
   * @param {function(Event)} listener The listener for event to
   *        register.
   */

	}, {
		key: 'unlisten',
		value: function unlisten(eventTarget, eventName, listener) {
			var realListener = this[PRIVATE.deregisterListener](this[PRIVATE.eventBusListeners], eventTarget, eventName, listener);

			if (realListener) {
				_get(AbstractManagedComponent.prototype.__proto__ || Object.getPrototypeOf(AbstractManagedComponent.prototype), 'unlisten', this).call(this, eventTarget, eventName, realListener);
			}
		}

		/**
   * Registers the provided event listener to be executed when the
   * specified event occurs on the IMA event dispatcher.
   *
   * The listener will be automatically deregistered right before the
   * component will be unmounted from the DOM (by the
   * {@linkcode componentWillUnmount()} method).
   *
   * The listener will automatically have its {@code this} context bound
   * to this instance.
   *
   * @param {string} eventName The name of the event.
   * @param {function(*)} listener The event listener to register.
   */

	}, {
		key: 'addDispatcherListener',
		value: function addDispatcherListener(eventName, listener) {
			if (!this[PRIVATE.dispatcherListeners].has(eventName)) {
				this[PRIVATE.dispatcherListeners].set(eventName, new Set());
			}
			var listeners = this[PRIVATE.dispatcherListeners].get(eventName);

			this.utils.$Dispatcher.listen(eventName, listener, this);

			listeners.add(listener);
		}

		/**
   * Deregisters the provided event listener from execution of the
   * occurrence of the specified event on the IMA event dispatcher.
   *
   * The method has no effect if the listener is not registered.
   *
   * @param {string} eventName The name of the event.
   * @param {function(*)} listener The event listener to deregister.
   */

	}, {
		key: 'removeDispatcherListener',
		value: function removeDispatcherListener(eventName, listener) {
			if (!this[PRIVATE.dispatcherListeners].has(eventName)) {
				return;
			}
			var listeners = this[PRIVATE.dispatcherListeners].get(eventName);
			if (!listeners.has(listener)) {
				return;
			}

			this.utils.$Dispatcher.unlisten(eventName, listener, this);

			listeners.delete(listener);
			if (!listeners.size()) {
				this[PRIVATE.dispatcherListeners].delete(eventName);
			}
		}

		/**
   * Registers the provided callback to be executed after the specified
   * delay.
   *
   * The callback will be automatically deregistered right before the
   * component will be unmounted from the DOM (by the
   * {@linkcode componentWillUnmount()} method).
   *
   * The callback will automatically have its {@code this} context bound
   * to this instance.
   *
   * @param {function()} callback The callback to schedule for execution.
   * @param {number} delay The delay in milliseconds after which the
   *        callback should be executed.
   */

	}, {
		key: 'setTimeout',
		value: function (_setTimeout) {
			function setTimeout(_x, _x2) {
				return _setTimeout.apply(this, arguments);
			}

			setTimeout.toString = function () {
				return _setTimeout.toString();
			};

			return setTimeout;
		}(function (callback, delay) {
			var _this2 = this;

			if (this[PRIVATE.pendingTimeouts].has(callback)) {
				throw new Error('The provided callback is already pending ' + 'to be executed. If you need to reschedule the ' + 'callback execution, clear the callback\'s ' + 'scheduled timeout execution using the ' + 'clearTimeout() method first');
			}

			var timeoutId = setTimeout(function () {
				callback.call(_this2);
				_this2[PRIVATE.pendingTimeouts].delete(callback);
			}, delay);
			this[PRIVATE.pendingTimeouts].set(callback, timeoutId);
		})

		/**
   * Cancels the scheduled delayed execution of the provided callback. The
   * method has no effect if the callback is not registered for delayed
   * execution.
   *
   * @param {function()} callback The callback that is scheduled for
   *        execution.
   */

	}, {
		key: 'clearTimeout',
		value: function (_clearTimeout) {
			function clearTimeout(_x3) {
				return _clearTimeout.apply(this, arguments);
			}

			clearTimeout.toString = function () {
				return _clearTimeout.toString();
			};

			return clearTimeout;
		}(function (callback) {
			if (!this[PRIVATE.pendingTimeouts].has(callback)) {
				return; // nothing to do
			}

			clearTimeout(this[PRIVATE.pendingTimeouts].get(callback));
			this[PRIVATE.pendingTimeouts].delete(callback);
		})

		/**
   * Registers the provided callback to be executed periodically.
   *
   * The callback will be automatically deregistered right before the
   * component will be unmounted from the DOM (by the
   * {@linkcode componentWillUnmount()} method).
   *
   * The callback will automatically have its {@code this} context bound
   * to this instance.
   *
   * @param {function()} callback The callback to execute periodically.
   * @param {number} period The time period at which the provided
   *        callback should be executed, in milliseconds.
   */

	}, {
		key: 'setInterval',
		value: function (_setInterval) {
			function setInterval(_x4, _x5) {
				return _setInterval.apply(this, arguments);
			}

			setInterval.toString = function () {
				return _setInterval.toString();
			};

			return setInterval;
		}(function (callback, period) {
			var _this3 = this;

			if (this[PRIVATE.activeIntervals].has(callback)) {
				throw new Error('The provided callback is already ' + 'registered to be executed periodically. If you ' + 'need to reschedule the callback execution, clear ' + 'the callback\'s scheduled interval execution using ' + 'the clearInterval() method first');
			}

			var intervalId = setInterval(function () {
				callback.call(_this3);
				_this3[PRIVATE.activeIntervals].delete(callback);
			}, period);
			this[PRIVATE.activeIntervals].set(callback, intervalId);
		})

		/**
   * Cancels the periodic execution of the provided callback. The method
   * has no effect if the callback is not registered of execution.
   *
   * @param {function()} callback The callback that should no longer be
   *        executed periodically.
   */

	}, {
		key: 'clearInterval',
		value: function (_clearInterval) {
			function clearInterval(_x6) {
				return _clearInterval.apply(this, arguments);
			}

			clearInterval.toString = function () {
				return _clearInterval.toString();
			};

			return clearInterval;
		}(function (callback) {
			if (!this[PRIVATE.activeIntervals].has(callback)) {
				return; // nothing to do
			}

			clearInterval(this[PRIVATE.activeIntervals].get(callback));
			this[PRIVATE.activeIntervals].delete(callback);
		})

		/**
   * Deregisters all the registered event bus, dispatcher and DOM event
   * listeners and cancels all the pending timeouts and active intervals
   * registered by this component.
   *
   * @override
   */

	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			var eventBusListeners = this[PRIVATE.eventBusListeners];
			var _iteratorNormalCompletion = true;
			var _didIteratorError = false;
			var _iteratorError = undefined;

			try {
				for (var _iterator = eventBusListeners.keys()[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
					var eventTarget = _step.value;

					var eventListeners = eventBusListeners.get(eventTarget);
					var _iteratorNormalCompletion6 = true;
					var _didIteratorError6 = false;
					var _iteratorError6 = undefined;

					try {
						for (var _iterator6 = eventListeners.keys()[Symbol.iterator](), _step6; !(_iteratorNormalCompletion6 = (_step6 = _iterator6.next()).done); _iteratorNormalCompletion6 = true) {
							var eventName = _step6.value;

							var realListeners = eventListeners.get(eventName).values();
							var _iteratorNormalCompletion7 = true;
							var _didIteratorError7 = false;
							var _iteratorError7 = undefined;

							try {
								for (var _iterator7 = realListeners[Symbol.iterator](), _step7; !(_iteratorNormalCompletion7 = (_step7 = _iterator7.next()).done); _iteratorNormalCompletion7 = true) {
									var realListener = _step7.value;

									_get(AbstractManagedComponent.prototype.__proto__ || Object.getPrototypeOf(AbstractManagedComponent.prototype), 'unlisten', this).call(this, eventTarget, eventName, realListener);
								}
							} catch (err) {
								_didIteratorError7 = true;
								_iteratorError7 = err;
							} finally {
								try {
									if (!_iteratorNormalCompletion7 && _iterator7.return) {
										_iterator7.return();
									}
								} finally {
									if (_didIteratorError7) {
										throw _iteratorError7;
									}
								}
							}
						}
					} catch (err) {
						_didIteratorError6 = true;
						_iteratorError6 = err;
					} finally {
						try {
							if (!_iteratorNormalCompletion6 && _iterator6.return) {
								_iterator6.return();
							}
						} finally {
							if (_didIteratorError6) {
								throw _iteratorError6;
							}
						}
					}
				}
			} catch (err) {
				_didIteratorError = true;
				_iteratorError = err;
			} finally {
				try {
					if (!_iteratorNormalCompletion && _iterator.return) {
						_iterator.return();
					}
				} finally {
					if (_didIteratorError) {
						throw _iteratorError;
					}
				}
			}

			var domListeners = this[PRIVATE.domListeners];
			var _iteratorNormalCompletion2 = true;
			var _didIteratorError2 = false;
			var _iteratorError2 = undefined;

			try {
				for (var _iterator2 = domListeners.keys()[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
					var _eventTarget = _step2.value;

					var _eventListeners = domListeners.get(_eventTarget);
					var _iteratorNormalCompletion8 = true;
					var _didIteratorError8 = false;
					var _iteratorError8 = undefined;

					try {
						for (var _iterator8 = _eventListeners.keys()[Symbol.iterator](), _step8; !(_iteratorNormalCompletion8 = (_step8 = _iterator8.next()).done); _iteratorNormalCompletion8 = true) {
							var _eventName = _step8.value;

							var _realListeners = _eventListeners.get(_eventName).values();
							var _iteratorNormalCompletion9 = true;
							var _didIteratorError9 = false;
							var _iteratorError9 = undefined;

							try {
								for (var _iterator9 = _realListeners[Symbol.iterator](), _step9; !(_iteratorNormalCompletion9 = (_step9 = _iterator9.next()).done); _iteratorNormalCompletion9 = true) {
									var _realListener = _step9.value;

									_eventTarget.removeEventListener(_eventName, _realListener);
								}
							} catch (err) {
								_didIteratorError9 = true;
								_iteratorError9 = err;
							} finally {
								try {
									if (!_iteratorNormalCompletion9 && _iterator9.return) {
										_iterator9.return();
									}
								} finally {
									if (_didIteratorError9) {
										throw _iteratorError9;
									}
								}
							}
						}
					} catch (err) {
						_didIteratorError8 = true;
						_iteratorError8 = err;
					} finally {
						try {
							if (!_iteratorNormalCompletion8 && _iterator8.return) {
								_iterator8.return();
							}
						} finally {
							if (_didIteratorError8) {
								throw _iteratorError8;
							}
						}
					}
				}
			} catch (err) {
				_didIteratorError2 = true;
				_iteratorError2 = err;
			} finally {
				try {
					if (!_iteratorNormalCompletion2 && _iterator2.return) {
						_iterator2.return();
					}
				} finally {
					if (_didIteratorError2) {
						throw _iteratorError2;
					}
				}
			}

			var dispatcherListeners = this[PRIVATE.dispatcherListeners];
			var _iteratorNormalCompletion3 = true;
			var _didIteratorError3 = false;
			var _iteratorError3 = undefined;

			try {
				for (var _iterator3 = dispatcherListeners.keys()[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
					var _eventName2 = _step3.value;
					var _iteratorNormalCompletion10 = true;
					var _didIteratorError10 = false;
					var _iteratorError10 = undefined;

					try {
						for (var _iterator10 = dispatcherListeners.get(_eventName2)[Symbol.iterator](), _step10; !(_iteratorNormalCompletion10 = (_step10 = _iterator10.next()).done); _iteratorNormalCompletion10 = true) {
							var listener = _step10.value;

							this.utils.$Dispatcher.unlisten(_eventName2, listener, this);
						}
					} catch (err) {
						_didIteratorError10 = true;
						_iteratorError10 = err;
					} finally {
						try {
							if (!_iteratorNormalCompletion10 && _iterator10.return) {
								_iterator10.return();
							}
						} finally {
							if (_didIteratorError10) {
								throw _iteratorError10;
							}
						}
					}
				}
			} catch (err) {
				_didIteratorError3 = true;
				_iteratorError3 = err;
			} finally {
				try {
					if (!_iteratorNormalCompletion3 && _iterator3.return) {
						_iterator3.return();
					}
				} finally {
					if (_didIteratorError3) {
						throw _iteratorError3;
					}
				}
			}

			var _iteratorNormalCompletion4 = true;
			var _didIteratorError4 = false;
			var _iteratorError4 = undefined;

			try {
				for (var _iterator4 = this[PRIVATE.pendingTimeouts].values()[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
					var timeoutId = _step4.value;

					clearTimeout(timeoutId);
				}
			} catch (err) {
				_didIteratorError4 = true;
				_iteratorError4 = err;
			} finally {
				try {
					if (!_iteratorNormalCompletion4 && _iterator4.return) {
						_iterator4.return();
					}
				} finally {
					if (_didIteratorError4) {
						throw _iteratorError4;
					}
				}
			}

			var _iteratorNormalCompletion5 = true;
			var _didIteratorError5 = false;
			var _iteratorError5 = undefined;

			try {
				for (var _iterator5 = this[PRIVATE.activeIntervals].values()[Symbol.iterator](), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
					var intervalId = _step5.value;

					clearInterval(intervalId);
				}

				// clear the managed listeners
			} catch (err) {
				_didIteratorError5 = true;
				_iteratorError5 = err;
			} finally {
				try {
					if (!_iteratorNormalCompletion5 && _iterator5.return) {
						_iterator5.return();
					}
				} finally {
					if (_didIteratorError5) {
						throw _iteratorError5;
					}
				}
			}

			this[PRIVATE.eventBusListeners].clear();
			this[PRIVATE.domListeners].clear();
			this[PRIVATE.dispatcherListeners].clear();
			this[PRIVATE.pendingTimeouts].clear();
			this[PRIVATE.activeIntervals].clear();
		}

		/**
   * Registers the specified event listeners within the provided storage.
   * The structure of the storage will be automatically updated as
   * necessary.
   *
   * The method returns a new listener that will execute the provided
   * listener with the {@code this} context bound to this component
   * instance.
   *
   * @param {Map<EventTarget, Map<string, Map<
   *          function(Event),
   *          function(Event)
   *        >>>} listenerStorage The storage of the managed events.
   * @param {(ReactComponent|EventTarget)} eventTarget The event target
   *        at which the event will be listened for.
   * @param {string} eventName The name of the event on which the
   *        listener is to be executed.
   * @param {function(*)} listener The event listener to execute on the
   *        specified event's occurrence.
   * @return {?function(*)} The listener to pass to the underlying event
   *         API.
   */

	}, {
		key: PRIVATE.registerListener,
		value: function value(listenerStorage, eventTarget, eventName, listener) {
			if (!eventTarget.addEventListener) {
				eventTarget = this.findDOMNode(eventTarget);
			}

			if (!listenerStorage.has(eventTarget)) {
				listenerStorage.set(eventTarget, new Map());
			}
			var eventListeners = listenerStorage.get(eventTarget);
			if (!eventListeners.has(eventName)) {
				eventListeners.set(eventName, new Map());
			}
			var listeners = eventListeners.get(eventName);
			if (listeners.has(listener)) {
				return null; // already listening for the event
			}

			var realListener = listener.bind(this);
			listeners.set(listener, realListener);

			return realListener;
		}

		/**
   * Deregisters the specified event listener from the provided storage.
   * The method automatically clears off the empty parts of the storage's
   * tree structure that would be left after the removal of the event
   * listener.
   *
   * @param {Map<EventTarget, Map<string, Map<
   *          function(Event),
   *          function(Event)
   *        >>>} listenerStorage The storage of the managed events.
   * @param {(ReactComponent|EventTarget)} eventTarget The event target
   *        at which the event was listened for.
   * @param {string} eventName The name of the event on which the
   *        listener was to be executed.
   * @param {function(*)} listener The listener that was to be executed
   *        on the specified event's occurrence.
   * @return {?function(*)} The listener that was passed to the
   *         underlying event API, or {@code null} if the provided
   *         listener was not registered.
   */

	}, {
		key: PRIVATE.deregisterListener,
		value: function value(listenerStorage, eventTarget, eventName, listener) {
			if (!eventTarget.addEventListener) {
				eventTarget = this.findDOMNode(eventTarget);
			}

			if (!listenerStorage.has(eventTarget)) {
				return null;
			}
			var eventListeners = listenerStorage.get(eventTarget);
			if (!eventListeners.has(eventName)) {
				return null;
			}
			var listeners = eventListeners.get(eventName);
			if (!listeners.has(listener)) {
				return null;
			}
			var realListener = listeners.get(listener);

			listeners.delete(listener);
			if (!listeners.size()) {
				eventListeners.delete(eventName);
			}
			if (!eventListeners.size()) {
				listenerStorage.delete(eventTarget);
			}

			return realListener;
		}

		/**
   * Post-processes the react element tree generated by this component's
   * {@linkcode render} method by binding all event listeners
   *
   * @param {ReactElement} reactElement The root react element craeted by
   *        this component's render() method.
   * @return {ReactElement} The post-processed tree of react elements.
   */

	}, {
		key: PRIVATE.bindUiEventListeners,
		value: function value(reactElement) {
			var _this4 = this;

			var clone = Object.assign({}, reactElement);
			Object.defineProperty(clone, '_self', {
				enumerable: false,
				configurable: false,
				value: reactElement._self
			});
			Object.defineProperty(clone, '_source', {
				enumerable: false,
				configurable: false,
				value: reactElement._source
			});

			var props = Object.assign({}, clone.props);
			var _iteratorNormalCompletion11 = true;
			var _didIteratorError11 = false;
			var _iteratorError11 = undefined;

			try {
				for (var _iterator11 = Object.keys(props)[Symbol.iterator](), _step11; !(_iteratorNormalCompletion11 = (_step11 = _iterator11.next()).done); _iteratorNormalCompletion11 = true) {
					var propertyName = _step11.value;

					if (propertyName.substring(0, 2) !== 'on' || typeof props[propertyName] !== 'function') {
						continue;
					}

					props[propertyName] = props[propertyName].bind(this);
				}
			} catch (err) {
				_didIteratorError11 = true;
				_iteratorError11 = err;
			} finally {
				try {
					if (!_iteratorNormalCompletion11 && _iterator11.return) {
						_iterator11.return();
					}
				} finally {
					if (_didIteratorError11) {
						throw _iteratorError11;
					}
				}
			}

			if (props.children instanceof Array) {
				props.children = props.children.map(function (child) {
					return _this4[PRIVATE.bindUiEventListeners](child);
				});
			} else if (props.children instanceof Object) {
				props.children = this[PRIVATE.bindUiEventListeners](props.children);
			}

			clone.props = Object.freeze(props);
			return Object.freeze(clone);
		}
	}]);

	return AbstractManagedComponent;
}(_AbstractComponent3.default);

exports.default = AbstractManagedComponent;